; Definiciones varias incluidas en el tutorial de ACL2

(defun mapnil (x)
  (if (consp x)
      (cons nil (mapnil (cdr x)))
    nil))

(defun add (x y)
  (if (consp x)
      (cons nil (add (cdr x) y))
    (mapnil y)))

(defun app (a b)
  (if (consp a)
      (cons (car a) (app (cdr a) b))
    b))

(defun mem (e x)
  (if (consp x)
      (if (equal e (car x))
	  x
	(mem e (cdr x)))
    nil))

(defun lonesomep (e lst)
  (if (mem e lst)
      (not (mem e (cdr (mem e lst))))
    nil))

(defun collect-lonesomep (a b)
  (if (consp a)
      (if (lonesomep (car a) b)
	  (cons (car a)
		(collect-lonesomep (cdr a) b))
	(collect-lonesomep (cdr a) b))
    nil))

(defun mult (x y)
  (if (consp x)
      (add y (mult (cdr x) y))
    nil))

(defun fact (n)
  (if (consp n)
      (mult n (fact (cdr n)))
    '(nil)))

(defun fact1 (n a)
  (if (consp n)
      (fact1 (cdr n) (mult n a))
    a))

(defun foundp (x a)
  (if (consp a)
      (if (equal x (car (car a)))
	  t
	(foundp x (cdr a)))
    nil))

(defun memp (e x)
  (if (consp x)
      (if (equal e (car x))
	  t
	(memp e (cdr x)))
    nil))

(defun int (x y)
  (if (consp x)
      (if (memp (car x) y)
	  (cons (car x) (int (cdr x) y))
	(int (cdr x) y))
    nil))

(defun leaves (x)
  (if (consp x)
      (app (leaves (car x))
	   (leaves (cdr x)))
    (cons x nil)))

(defun lonesomes (x)
  (collect-lonesomep (leaves x) (leaves x)))

(defun lookup (x a)
  (if (consp a)
      (if (equal x (car (car a)))
	  (cdr (car a))
	(lookup x (cdr a)))
    nil))

(defun mc-flatten (x a)
  (if (consp x)
      (mc-flatten (car x)
		  (mc-flatten (cdr x) a))
    (cons x a)))

(defun nump (x)
  (if (consp x)
      (and (equal (car x) nil)
	   (nump (cdr x)))
    (equal x nil)))

(defun properp (x)
  (if (consp x)
      (properp (cdr x))
    (equal x nil)))

(defun raise (x y)
  (if (consp y)
      (mult x (raise x (cdr y)))
    '(nil)))

(defun subp (x y)
  (if (consp x)
      (if (memp (car x) y)
	  (subp (cdr x) y)
	nil)
    t))

(defun seteqp (x y)
  (and (subp x y)
       (subp y x)))

(defun ziplists (x y)
  (if (consp x)
      (cons (cons (car x) (car y))
	    (ziplists (cdr x) (cdr y)))
    nil))
